package cn.net.cpzslibs.prot.handset.newProt;

import android.util.Log;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20001ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20001ResBean;


public class Prot20001Product extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode20001 = 20001;
	private Gson gson;
	private Prot20001ResBean resBean;
	
	public Prot20001Product() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	/*public String getJsonData() {
		return jsonData;
	}*/
	public Prot20001ResBean getResBean(){
		return this.resBean;
	}

    public void setResBean(Prot20001ResBean resBean) {
        this.resBean = resBean;
    }

    public void reqProductList(SocketCreate create, Prot20001ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20001ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20001, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20001, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20001, jsonData);
		/*if (!StrUtils.isEmpty(jsonData)) {
			labelResult = gson.fromJson(jsonData, Prot10046ResultBean.class);
		}*/
		resBean = gson.fromJson(jsonData, Prot20001ResBean.class);
		System.err.println("resBean: " + resBean.toString());
		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param=iUserType
	 * @param=loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20001ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20001, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
